// main.cpp
//--------

#include <typeinfo.h>
#include "msg.h"

//	For non-MVC compilers:
//-----------------------
#ifndef TRACE
#define TRACE void
#endif

// messages A,B,C
//------------------
class A:public Msg
{
public:
	A() :	a(10) {};
	int a;
};

class B:public Msg
{
public:
	B() : b(11) {};
	int b;
};

class C:public Msg
{
public:
	C() : c(12) {};
	int c;
};

// Object capable to receive messages A and B
//---------------------------------------------
class Object: public Handler<A>,public Handler<B>
{
public:
	void OnNotify (const A&);
	void OnNotify (const B&);

};
//	functions to receive messages
void Object::OnNotify (const A& msg)
{
	TRACE ("Object::OnNotify (const A& msg)\n");
};

void Object::OnNotify (const B& msg)
{
	TRACE ("Object::OnNotify (const B& msg)\n");
};


void fun (Target* pTarget)
{
	A msga;
	B msgb;
	C msgc;
			// send messages A,B,C to Target 
			// (now the real type of target is not known)
	pTarget->Notify (msga);
	pTarget->Notify (msgb);
	pTarget->Notify (msgc);	// this message cannot be received
}


void main ()
{
	Object ob;	
	fun (&ob);
}

