// msg.cpp
//--------

#include <typeinfo.h>
#include "msg.h"


void Target::Notify (const Msg& msg)
{
	HandlerBase* pthis = Vtable.Find(typeid(msg).raw_name());
	// find out the appropriate handler for given message type
	if (pthis!=0)
	{
			// indirectly call OnNotify through virtual 
			// base class member
		pthis->IndirectCall(msg);
	}
	else
	{
		// do something if target have no handler for 
		// dispatched message
		//...
	}

}

//----------------------------------
// Container for fast handler access
//----------------------------------

#ifdef STL_STYLE
HandlerBase*	Target::Container::Find(const string& classname)
{	iterator it=find (classname);
	return (it!=end()) ? (*it).second : 0;
}

void Target::Container::Insert (const string& classname, HandlerBase* handler)
{
	operator[](classname)=handler;
}

void Target::Container::Erase  (const string& classname)
{	erase (classname);
}

#else
HandlerBase*	Target::Container::Find(LPCTSTR classname)
{	HandlerBase*	pHandler;
	return Lookup(classname, pHandler) ? pHandler : 0;
}

void Target::Container::Insert (LPCTSTR classname, HandlerBase* handler)
{
	operator[](classname)=handler;
}

void Target::Container::Erase  (LPCTSTR classname)
{	RemoveKey (classname);
}
#endif
